<?php

namespace App\domain\travelport\ticketing;

use App\domain\travelport\Workbench;

class AddPaymentAction extends Workbench
{
    protected string $ticketWorkbenchAuthorityValue;
    protected string $payType;
    protected string $currencyCode;
    protected float $amount;
    protected string $formOfPaymentIdentifier;
    protected string $offerIdentifier;
    private string $offerId;

    public function execute(
        string $ticketWorkbenchAuthorityValue,
        string $payType,
        string $currencyCode,
        float $amount,
        string $formOfPaymentIdentifier,
        string $offerIdentifier,
        string $offerId,
    )
    {
        $this->ticketWorkbenchAuthorityValue = $ticketWorkbenchAuthorityValue;
        $this->payType = $payType;
        $this->currencyCode = $currencyCode;
        $this->amount = $amount;
        $this->formOfPaymentIdentifier = $formOfPaymentIdentifier;
        $this->offerIdentifier = $offerIdentifier;
        $this->offerId= $offerId;

        return $this->travelportPost();
    }

    protected function buildApiUrl(): string
    {
        return "https://{$this->baseURL}/{$this->apiVersion}/air/paymentoffer/reservationworkbench/{$this->ticketWorkbenchAuthorityValue}/payments";
    }

    protected function createPayload(): array
    {
        return [
            "Payment" => [
                "id" => "payment_1",
                "Identifier" => [
                    "authority" => "Travelport",
                    "value" => $this->formOfPaymentIdentifier
                ],
                "Amount" => [
                    "code" => $this->currencyCode,
                    "minorUnit" => 2,
                    "currencySource" => "Charged",
                    "approximateInd" => true,
                    "value" => $this->amount
                ],
                "FormOfPaymentIdentifier" => [
                    "id" => "formOfPayment_10",
                    "FormOfPaymentRef" => "formOfPayment_10",
                    "Identifier" => [
                        "authority" => "Travelport",
                        "value" => $this->formOfPaymentIdentifier
                    ]
                ],
                "OfferIdentifier" => [
                    [
                        "id" => $this->offerId,
                        "offerRef" => $this->offerId,
                        "Identifier" => [
                            "authority" => "Travelport",
                            "value" => $this->offerIdentifier
                        ]
                    ]
                ]
            ]
        ];


    }
}
